typedef unsigned char byte;
typedef unsigned short word;
typedef unsigned long dword;

#define LCD_E  (1 << 4) // portc
#define LCD_RS (1 << 6) // portc
#define LCD_RW (1 << 5) // portc

#define lcd_set_e()  (PORTC |= LCD_E)
#define lcd_set_rs() (PORTC |= LCD_RS)
#define lcd_set_rw() (PORTC |= LCD_RW)

#define lcd_clear_e()  (PORTC &= ~LCD_E)
#define lcd_clear_rs() (PORTC &= ~LCD_RS)
#define lcd_clear_rw() (PORTC &= ~LCD_RW)

void delay(dword ticks)
	{ 
	while(ticks--)
		;
	}

void lcd_pulse(void)
	{
	lcd_set_e();
	delay(15);
	lcd_clear_e();
	delay(15);
	}

void lcd_wait(void)
	{
	delay(2500);
	}

void lcd_send(byte data)
	{
	PORTA = data;  
	lcd_pulse();
	}

void clrscr(void)
	{      
	delay(5);
	lcd_clear_rs();
	delay(5);
	lcd_clear_rw();
	delay(5);
	lcd_send(0x01);
	lcd_wait();
	}

void initgraph(void)
	{
	DDRC |= (LCD_E | LCD_RS | LCD_RW);
	DDRA = 0xFF;
	lcd_clear_rw();
	lcd_clear_rs();
	lcd_wait(); 
	lcd_send(0x3C); 
	lcd_wait(); 
	lcd_send(0x3C);
	lcd_wait(); 
	lcd_send(0x3C);
	lcd_wait(); 
	lcd_send(0x06);
	lcd_wait(); 
	lcd_send(0x0C);
	lcd_wait(); 
	lcd_send(0x01);
	lcd_wait(); 
	}    

void gotoz(byte z)
	{
	lcd_clear_rw();
	lcd_clear_rs();
	lcd_send(z | 0x80);
	}

#define gotoxy(x,y) gotoz(x|(y<<6))

void putchar(char c)
	{
	lcd_clear_rw();
	lcd_set_rs();
	lcd_send(c);
	}

void outtext_const(const char * const s)
	{
	byte i;
	for(i = 0; s[i]; i++)
		putchar(s[i]);
	}

void outtext(char * s)
	{
	byte i;
	for(i = 0; s[i]; i++)
		putchar(s[i]);
	}

	
